﻿using DDF_sql_services.daos;
using dlu_persistence_api;
using dlu_persistence_api.daos;
using dlu_persistence_api.models;
using Infragistics.Documents.Excel;
using Infragistics.Windows.DataPresenter;
using Infragistics.Windows.DataPresenter.ExcelExporter;
using LokalPlanner.models;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Diagnostics;
using System.Globalization;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Forms;
using System.Windows.Markup;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using LokalPlanner.service;
using MessageBox = System.Windows.Forms.MessageBox;
using System.Windows.Input;
using Infragistics.Windows;

namespace LokalPlanner
{
    /// <summary>
    /// Interaction logic for MediePlan.xaml
    /// </summary>
    public partial class MediePlan : Page
    {
        private ObservableCollection<AvisTIlGrid> avisTIlGrids { get; set; }
        private List<Annoncøer> annoncør { get; set; }
        private List<Bureau> Bureau { get; set; }
        private DPKulør pKulør { get; set; }
        private BureaoDao bureaoDao;
        private AnnonøcerDAO annonøcerDAO;
        private DPKuloerDao kuloerDao;
        private PlaceringDao placeringDao;
        private MediePlanAviserDao aviserDao;
        private MediePlanLinjerDao mediePlanLinjerDao;
        private MedieplanÆndringerDao medieplanÆndringerDao;
        private MediaPlanNrDao mediaPlanNrDao;

        private List<string> kommentar { get; set; }
        List<Cell> _cells = new List<Cell>();
        private MediePlanDao mediePlanDao;
        private LokalPlanner.service.SecurityUserService security;
        private LokalPlanner.service.ValidationServive validationServive;


        private int placeringid { get; set; }
        private int medieplanNr { get; set; }
        private int Version { get; set; }
        private int AktivVersion { get; set; }
        private int year { get; set; }
        private decimal? oldvalue { get; set; }
        private bool opret { get; set; }
        private bool opdater { get; set; }
        private short version { get; set; }
        private decimal oldTotalValue { get; set; }
        private decimal oldMMrabat { get; set; }
        private decimal oldFarveRabat { get; set; }
        private BeregnerService beregnerService;
        private FarveberegnerService farveberegnerService;
        NumberStyles style;
        CultureInfo provider;

        private ExportOptions _exportOptions;
        public MediePlan()
        {

            BureaoDao = new BureaoDao();
            AnnonøcerDAO = new AnnonøcerDAO();
            Bureau = BureaoDao.GetListbureauer();
            annoncør = AnnonøcerDAO.GetAnnoncøer();
            KuloerDao = new DPKuloerDao();
            PlaceringDao = new PlaceringDao();
            AviserDao = new MediePlanAviserDao();
            BeregnerService = new BeregnerService();
            FarveberegnerService = new FarveberegnerService();
            MediePlanDao = new MediePlanDao();
            MediePlanLinjerDao = new MediePlanLinjerDao();
            MediaPlanNrDao = new MediaPlanNrDao();
            MedieplanÆndringerDao = new MedieplanÆndringerDao();
            avisTIlGrids = new ObservableCollection<AvisTIlGrid>();
            Security = new service.SecurityUserService();
            ValidationServive = new service.ValidationServive();
            Bureau.Insert(0, new Bureau()
            {
                Annoncør = "-Vælg Bureau-",
                AnnoncørID = "0",
                Company_No_ = "0"
            });
            annoncør.Insert(0, new Annoncøer
            {
                AnnoncørID = "0",
                Annoncør = "-Vælg Annoncør-",
                Bill_to_Contact_No_ = "0"
            });
            InitializeComponent();


            setBureaList();
            setAnnoncøerList();
            setFarveListe();
            setPlacering();

            setObserver();
            Style1 = NumberStyles.AllowDecimalPoint | NumberStyles.AllowThousands;
            Provider = new CultureInfo("dk-DK");
            indrÅr.Text = "" + System.DateTime.Now.Year;
            int uge = GetIso8601WeekOfYear() + 1;
            indrUge.Text = "" + uge;
            opret = true;


        }



        private void setObserver()
        {

            ObserverQueue.ides.CollectionChanged += (ss, ee) =>
            {
                if (ee.Action == System.Collections.Specialized.NotifyCollectionChangedAction.Add)
                {
                    int addedObject = int.Parse(ee.NewItems[0].ToString());
                    try
                    {
                        int placerering = 1;

                        try
                        {
                            var res = AviserDao.GetAllUgeAvisTilGrid(addedObject, System.DateTime.UtcNow.Year, placerering);
                            if (res != null)
                            {
                                res.MmRabat = 0;
                                var mmtotal = (decimal)Math.Round(res.MmPris.Value, 2) * (decimal)Math.Round(double.Parse(format2.Text), 2) * (decimal)0.30;
                                res.OldMmtotal = (decimal)Math.Round(res.MmPris.Value, 2) * (decimal)Math.Round(double.Parse(format2.Text), 2);


                                var mmPris = (decimal)Math.Round(BeregnerService.BeregnMmPris(decimal.Parse(format1.Text), decimal.Parse(format2.Text), res, miljøTillægvisesIGrid.IsChecked.Value), 2);

                                res.MmTotal = mmPris;
                                res.OldMmtotal = mmPris;
                                res.Medlemaar = (byte?)(19 + res.Medlemaar);


                                res.FarvePris = Math.Round(FarveberegnerService.BeregnFarvePris(decimal.Parse(format1.Text), decimal.Parse(format2.Text), farve4.IsChecked.Value, res), 2);
                                res.FarveTotal = Math.Round(FarveberegnerService.BeregnFarvePris(decimal.Parse(format1.Text), decimal.Parse(format2.Text), farve4.IsChecked.Value, res), 2);
                                    //   res.MmPris = (decimal)(Math.Round(res.MmPris.Value, 2));
                                    res.totalPris = res.MmTotal + res.FarvePris;
                                res.oldTotalPris = Math.Round(res.MmPris.Value * (decimal.Parse(format1.Text) * decimal.Parse(format2.Text)), 2);



                                    //   res.webtillæg_type = res.webtillæg_type;
                                    res.MiljøTillæg = (decimal)res.MiljøTillæg;
                                avisTIlGrids.Add(res);
                                ChangeHasBeenMade();
                            }
                        }
                        catch (Exception ex)
                        {
                            Console.WriteLine("Add to medieplan " + ex.StackTrace);
                        }

                    }
                    catch (Exception ex)
                    {
                        Console.WriteLine(ex.StackTrace);
                    }



                }
            };

            LokalPlanner.MediePlanObserverQueue.gemSomDialog.CollectionChanged += (ss, ee) =>
            {
                if (ee.Action == System.Collections.Specialized.NotifyCollectionChangedAction.Add)
                {
                    LokalPlanner.models.GemSomDialogModel addedObject = (LokalPlanner.models.GemSomDialogModel)ee.NewItems[0];
                    try
                    {
                        var opretmedieplandNr = opretMediePlanNr(version);

                        version = opretmedieplandNr.Item2;
                        if (opretmedieplandNr.Item1 > 0)
                        {
                            var res = opretMediePlan(addedObject.Kontaktperson, addedObject.Beskrivelse, medieplanNr, version);
                            if (res)
                            {
                                TilFøjkMediePlanLinjer(version);
                            }
                        }


                    }
                    catch (Exception ex)
                    {
                        Console.WriteLine(ex.StackTrace);
                    }

                }
            };
            MediePlanObserverQueue.findMediePlanModels.CollectionChanged += (ss, ee) =>
            {
                if (ee.Action == System.Collections.Specialized.NotifyCollectionChangedAction.Add)
                {
                    var item = ee.NewItems[0] as LokalPlanner.models.FindMediePlanModel;
                    SetMediePlan(item);
                }
            };

            KopiMediaPlanObserver.tilNyModels.CollectionChanged += (ss, ee) =>
            {
                if (ee.Action == System.Collections.Specialized.NotifyCollectionChangedAction.Add)
                {
                    var item = ee.NewItems[0] as LokalPlanner.models.KopierTilNyModel;
                    if (item.ÅbenIBooking)
                    {
                        opretMediePlanNr(11);
                        opretMediePlan("", "", medieplanNr, 11);
                        TilFøjkMediePlanLinjer(11);
                        if (item.GenberegnRabatter)
                        {

                        }

                    }
                    else if (item.ÅbenIMediePlan)
                    {
                        opret = true;
                        opretMediePlanNr(1);
                        opretMediePlan("", "", medieplanNr, 1);
                        TilFøjkMediePlanLinjer(1);
                    }

                }
            };
        }

        private void SetMediePlan(FindMediePlanModel item)
        {
            var mediePlan = MediePlanDao.GetMediePlanByNumber(item.MediePlanNr, item.Version);
            foreach (var med in mediePlan.medieplannlinjer)
            {
                avisTIlGrids.Add(med);
            }
        }

        private void setPlacering()
        {
            var placeringer = PlaceringDao.GetPlaceringer();
            placeringCombo.DataContext = new { placering = placeringer };
            placeringCombo.SelectedItem = "PlaceringID";
            placeringCombo.SelectedIndex = 1;
            placeringCombo.Text = placeringer[1].Betegenlse;

        }
        private void setBureaList()
        {
            BureauCombo.DataContext = new { bureaus = Bureau };
            var res = Bureau.Find(s => s.AnnoncørID == "0");
            BureauCombo.SelectedItem = "AnnoncørID";
            BureauCombo.SelectedIndex = Bureau.IndexOf(res);
            BureauCombo.Text = Bureau[Bureau.IndexOf(res)].Annoncør;
        }

        private void setFarveListe()
        {
            farver.DataContext = new { farver = KuloerDao.GetDPKuloer() };

        }
        private void setAnnoncøerList()
        {

            Annoncør.DataContext = new { annoncøer = annoncør };
            var res = annoncør.Find(s => s.AnnoncørID == "0");
            Annoncør.SelectedItem = "AnnoncørID";
            Annoncør.SelectedIndex = annoncør.IndexOf(res);
            Annoncør.DisplayMemberPath = "Annoncør";
            Annoncør.Text = annoncør[annoncør.IndexOf(res)].Annoncør;
        }

        private void farve4_Click(object sender, RoutedEventArgs e)
        {
            var eve = e;
            /**
             *  <igWPF:TextField Name="Farve4Max" Label="Farve4Max" Visibility="Visible" />
                    <igWPF:TextField Name="Farve4Min" Label="Farve4Min"  Visibility="Visible"/>
                    <igWPF:TextField Name="Farve4Pris" Label="Farve4Pris" Visibility="Hidden" />
                    <igWPF:TextField Name="FarveMax" Label="FarveMax"  Visibility="Hidden"/>
                    <igWPF:TextField Name="FarveMin" Label="FarveMin" Visibility="Hidden" />
                    <igWPF:TextField Name="FarvePris" Label="FarvePris"  Visibility="Hidden"/>
             **/
            if (farve4.IsChecked.Value)
            {
                farve1.IsEnabled = false;
                farvesh.IsEnabled = false;
            }

            // dgAktiveAviser.FieldLayouts[0].Fields["OrdrecheckEmail"].Visibility = Visibility.Hidden;
            mediePlaner.FieldLayouts[0].Fields["Farve4Min"].Visibility = Visibility.Visible;
            mediePlaner.FieldLayouts[0].Fields["Farve4Max"].Visibility = Visibility.Visible;
            //  mediePlaner.FieldLayouts[0].Fields["Farve4Pris"].Visibility = Visibility.Visible;
            mediePlaner.FieldLayouts[0].Fields["FarveMax"].Visibility = Visibility.Collapsed;
            mediePlaner.FieldLayouts[0].Fields["FarveMin"].Visibility = Visibility.Collapsed;
            mediePlaner.FieldLayouts[0].Fields["FarvePris"].Visibility = Visibility.Collapsed;

        }

        private void farve1_Click(object sender, RoutedEventArgs e)
        {
            mediePlaner.FieldLayouts[0].Fields["Farve4Min"].Visibility = Visibility.Hidden;
            mediePlaner.FieldLayouts[0].Fields["Farve4Max"].Visibility = Visibility.Hidden;
            //     mediePlaner.FieldLayouts[0].Fields["Farve4Pris"].Visibility = Visibility.Hidden;
            mediePlaner.FieldLayouts[0].Fields["FarveMax"].Visibility = Visibility.Visible;
            mediePlaner.FieldLayouts[0].Fields["FarveMin"].Visibility = Visibility.Visible;
            mediePlaner.FieldLayouts[0].Fields["FarvePris"].Visibility = Visibility.Visible;
            farve1.Visibility = Visibility.Hidden;
            farver.Visibility = Visibility.Visible;
        }

        private void ChangeHasHapped(string id)
        {
            status_image.Source = Source(id);

        }

        private BitmapImage Source(string id)
        {
            BitmapImage image = new BitmapImage(new Uri("/Resources/" + id + ".png", UriKind.Relative));
            return image;

        }

        private void Opret_Click(object sender, RoutedEventArgs e)
        {
            if (ValidationServive.Validations.Count > 0)
            {
                string s = null;
                ValidationServive.Validations.ForEach(ss =>
                {
                    s += ss + Environment.NewLine;
                });
                MessageBox.Show(s);
            }
            else
            {
                if (status_image.Source.ToString().Contains("green_circle") || status_image.Source.ToString().Contains("yellow1_circle"))
                {
                    if (opret && !opdater)
                    {
                        version = 1;
                    }
                    else if (opdater && !opret)
                    {
                        short i = 1;
                        version = (short)(version + i);
                    }
                    var dialog = new LokalPlanner.dialogs.OpretMediePlanDialog();
                    dialog.ShowDialog();
                }

            }


        }

        private void ChangeHasBeenMade()
        {
            if (mediePlanNr.Content.ToString().Any(Char.IsDigit) && labelsStaus.ToString().Count() > 0)
            {
                ChangeHasHapped("yellow1_circle");
            }

        }

        private void TilFøjkMediePlanLinjer(short version)
        {

            var records = mediePlaner.Records;
            foreach (var record in records)
            {
                var item = ((DataRecord)record).DataItem as AvisTIlGrid;
                if (item != null)
                {

                    try
                    {
                        var linje = new tblMedieplanLinjer();
                        linje.Total = (decimal)item.totalPris;
                        linje.TotalInclTillæg = (decimal)item.TotalIncltillæg;
                        linje.TotalPris = item.totalPris;
                        linje.UgeavisID = item.BladID;
                        linje.Version = version;
                        linje.Bemærkning = item.bemærkning;
                        linje.BureauOrdreNr = "0"; //TODO 
                        linje.ErWeekendGruppe = false; //TODO
                        linje.FarveMax = (decimal)item.FarveMax;
                        linje.FarveMin = (decimal)item.FarveMin;
                        linje.FarvePris = (decimal)item.FarvePris;
                        linje.FarveRabat = item.FarveRabat;
                        linje.FarveTillæg = item.FarveTillæg;
                        linje.FarveTotal = item.FarveTotal;
                        linje.MedieplanNr = medieplanNr;
                        linje.Mm = item.Mm;
                        linje.MmRabat = item.MmRabat;
                        linje.SendeGruppe = item.HovedGruppeNavn;
                        linje.MedIGrupper = "";
                        linje.MaterialeNr = "";
                        linje.Bemærkning = new TextRange(Bemærkinng.Document.ContentStart, Bemærkinng.Document.ContentEnd).Text;



                        var task = MediePlanLinjerDao.CreateOrUpdateMediePlanLinjer(linje).Result;
                        OpdatereKommentar(medieplanNr, "Avis " + item.Navn + " er blevet tilføjet");


                    }
                    catch (Exception ex)
                    {
                        Console.WriteLine("Opret MediePlanlinjer dao " + ex.InnerException);
                    }
                }
            }
        }

        private void UpdateGridAccordinToPlacering(int placering)
        {
            var records = mediePlaner.Records;

            foreach (var record in records)
            {
                var item = ((DataRecord)record).DataItem as AvisTIlGrid;
                var res = AviserDao.GetAllUgeAvisTilGrid(item.BladID, System.DateTime.Now.Year, placering);
                if (res != null)
                {
                    var blad = avisTIlGrids.Where(s => s.BladID == res.BladID).FirstOrDefault<AvisTIlGrid>();
                    blad.Farve4Max = res.Farve4Max;
                    blad.Farve4Min = res.Farve4Min;
                    blad.Farve4Pris = res.Farve4Pris;
                    blad.FarveMax = res.FarveMax;
                    blad.FarveMin = res.FarveMin;
                    blad.MmPris = res.MmPris;
                    blad.FarveTotal = (decimal.Parse(format2.Text)) * res.MmPris.Value;
                    blad.FarvePris = Math.Round(res.FarvePris.Value, 2);
                    blad.totalPris = Math.Round(res.MmPris.Value * (decimal.Parse(format1.Text, Style1, Provider) * decimal.Parse(format2.Text, Style1, Provider)), 2);

                    blad.TotalIncltillæg = blad.totalPris + blad.FarveTillæg;
                    avisTIlGrids.Remove(blad);
                    avisTIlGrids.Add(blad);
                }
            }
        }
        private bool opretMediePlan(string kontaktPerson, string beskrivelse, int medieplannr, short version)
        {
            try
            {
                var mediePlan = new tblMedieplan();

                mediePlan.MedieplanNr = medieplannr;
                mediePlan.AntalFarver = (byte)setFarve();
                mediePlan.AnnoncørNo_ = (Annoncør.SelectedItem as Annoncøer).AnnoncørID;
                mediePlan.BureauNo_ = (BureauCombo.SelectedItem as Bureau).AnnoncørID;
                mediePlan.DPKulørID = (byte)setFarve();

                mediePlan.Format1 = (byte)int.Parse(format1.Text);
                mediePlan.Format2 = (byte)int.Parse(format2.Text);
                mediePlan.Beskrivelse = beskrivelse;
                mediePlan.Kontaktperson = kontaktPerson;
                mediePlan.KontaktpersonTilhører = 0;
                mediePlan.BemærkningTilAnnoncør = new TextRange(Bemærkinng.Document.ContentStart, Bemærkinng.Document.ContentEnd).Text;
                mediePlan.KonsulentCode = Security.GetCurrentUser();
                mediePlan.KunForhandlerBundForskellig = false;
                mediePlan.MaterialeFølgerFra = 0;
                mediePlan.MaterialeFølgerFraLeverandør = "";
                mediePlan.MaterialeGodtgørelseAlle = false;
                mediePlan.MiljøTillægOpkræves = true;
                mediePlan.Overskrift = "";
                mediePlan.RekvisitionsNr = "";
                mediePlan.RettelserEfterAnnoncekontrol = false;
                mediePlan.SamletPris = 0; //TODO;
                mediePlan.Version = version;
                mediePlan.BemærkningTilAnnoncør = "";
                mediePlan.BemærkningTilBlade = "";
                mediePlan.BilagsBladeATT = "";
                mediePlan.BilagsBladeTilAdresse = "";
                mediePlan.BilagsBladeTilPostNr = 0;
                mediePlan.FællesBureauOrdreNr = "0";
                mediePlan.BemærkningTilBlade = "";
                mediePlan.BilagsBladeTilNavn = "";
                mediePlan.OprettetDato = DateTime.Now;
                mediePlan.OrdreDato = DateTime.Now;
                mediePlan.RettelserEfterAnnoncekontrol = false;
                mediePlan.TilladFarveSærRabat = false;
                mediePlan.TilladMmSærRabat = false;
                var res = MediePlanDao.CreateOrUpdateMediePlan(mediePlan);
                if (res.Item2 != 0)
                {
                    mediePlanNr.Content = mediePlan.MedieplanNr + "-" + SetVersion("" + mediePlan.Version);

                    labelsStaus.Content = " Ny  Medieplan";
                    medieplanNr = medieplannr;
                    opret = false;
                    opdater = true;
                }
                return true;
            }
            catch (Exception ex)
            {
                Console.WriteLine("Opret MediePlan Error " + ex.InnerException);
            }
            return false;
        }
        private Tuple<int, short> opretMediePlanNr(short version = 1)
        {
            try
            {
                var table = new tblMedieplanNr();

                table.AktivVersion = version;
                if (!opret)
                {
                    table.MedieplanNr = medieplanNr;
                }
                table.FakturaBemærkning1 = "faktura bemærkning";
                table.FakturaBemærkning2 = "";
                table.FakturaBemærkning3 = "";
                table.AnvendtMiljøTillæg = 0;
                table.Kommentar = new TextRange(Kommentar.Document.ContentStart, Kommentar.Document.ContentEnd).Text;
                table.MaterialeModtaget = false;
                table.OverførtFraPrisforespørgsel = true;
                table.Status = 1;
                table.SupportBilagVedlagt = false;
                table.SupportBilagVist = false;
                var tuple = MediaPlanNrDao.CreateOrUpDateMediePlanNr(table);
                if (opret)
                {
                    medieplanNr = tuple.Item2;
                    version = tuple.Item3;
                    OpdatereKommentar(medieplanNr, "MediePlan Oprettet");
                }

                return new Tuple<int, short>(tuple.Item1, tuple.Item3);
            }
            catch (Exception ex)
            {
                Console.WriteLine("WPF opret mediePlan nr " + ex.InnerException);
            }
            return new Tuple<int, short>(0, 0);

        }

        public void OpdatereKommentar(int mediePlanNr, string text)
        {
            opretMediePlanÆndringer(medieplanNr, ændringstekst: text);
        }
        private void opretMediePlanÆndringer(int medieplanNr, string ændringstekst)
        {
            var aendring = new tblMedieplanÆndringer();
            aendring.MedieplanNr = medieplanNr;
            aendring.Version = version;
            aendring.ÆndringsTekst = ændringstekst;
            MedieplanÆndringerDao.CreateOrUpdate(aendring);
        }






        public int setFarve()
        {
            int farve = 0;
            if (farve1.IsChecked.Value)
            {
                farve = 1;
            }
            else if (farvesh.IsChecked.Value)
            {
                farve = 0;
            }
            else if (farve4.IsChecked.Value)
            {
                farve = 4;

            }
            return farve;

        }

        private void Page_Loaded(object sender, RoutedEventArgs e)
        {

            mediePlaner.DataSource = avisTIlGrids;
            mediePlaner.Language = XmlLanguage.GetLanguage(System.Windows.Application.Current.Dispatcher.Thread.CurrentUICulture.IetfLanguageTag);
        }



        private void mediePlaner_EditModeEnding(object sender, Infragistics.Windows.DataPresenter.Events.EditModeEndingEventArgs e)
        {
            try
            {
                var label = e.Cell.Field.Label.ToString();
                var reord = ((DataRecord)e.Cell.Record).DataItem as AvisTIlGrid;
                decimal ed = decimal.Parse(e.Editor.Value.ToString());
                var exa = decimal.Parse(e.Cell.Value.ToString());
                var avisInList = avisTIlGrids.Where(s => s.BladID == reord.BladID).FirstOrDefault<AvisTIlGrid>();
                var indexInList = avisTIlGrids.IndexOf(reord);
                if (label.Equals("Total"))
                {
                    var res = BeregnerService.BeregenPrisFraTotal(exa, ed, reord);
                    avisTIlGrids.RemoveAt(indexInList);
                    avisTIlGrids.Insert(indexInList, res);

                }
                else if (label.Equals("Mm Rabat"))
                {



                    var res = BeregnerService.BeregnePrisFraMMRabt(ed, reord);
                    avisTIlGrids.RemoveAt(indexInList);
                    avisTIlGrids.Insert(indexInList, reord);
                }
                else if (label.Equals("Farve Rabat"))
                {
                    var res = BeregnerService.BeregnePrisFarveRabat(ed, reord);
                    avisTIlGrids.RemoveAt(indexInList);
                    avisTIlGrids.Insert(indexInList, res);
                }
            }
            catch (Exception ex)
            {

            }


        }

        public int GetIso8601WeekOfYear()
        {
            CultureInfo myCI = new CultureInfo("dk-DK");
            System.Globalization.Calendar myCal = myCI.Calendar;
            CalendarWeekRule myCWR = myCI.DateTimeFormat.CalendarWeekRule;
            DayOfWeek myFirstDOW = myCI.DateTimeFormat.FirstDayOfWeek;
            return myCal.GetWeekOfYear(DateTime.Now, myCWR, myFirstDOW);
        }

        public void exportToExcel_Click(object sender, RoutedEventArgs e)
        {

            try
            {
                DataPresenterExcelExporter exporter = (DataPresenterExcelExporter)this.Resources["Exporter"];
                exporter.Export(this.mediePlaner, "excel.xlsx", WorkbookFormat.Excel2007, this.ExportOptions);
            }
            catch (Exception ex)
            {
                Console.WriteLine("export til excel " + ex.InnerException);
            }

            try
            {
                Process p = Process.GetCurrentProcess();
                p.StartInfo.FileName = "excel.xlsx";
                p.Start();
            }
            catch (Exception ex)
            {
                Console.WriteLine("Export to excel error " + ex.StackTrace);
            }

        }


        private void miljøTillægvisesIGrid_Click(object sender, RoutedEventArgs e)
        {

            mediePlaner.FieldLayouts[0].Fields["MiljøTillæg"].Visibility = Visibility.Visible;

            mediePlaner.FieldLayouts[0].Fields["TotalIncltillæg"].Visibility = Visibility.Visible;
            avisTIlGrids.OrderBy(s => s.Navn);
            avisTIlGrids.ToList<AvisTIlGrid>().ForEach(s =>
            {
                var index = avisTIlGrids.IndexOf(s);
                s.MmTotal = (decimal)Math.Round(BeregnerService.BeregnMmPris(decimal.Parse(format1.Text), decimal.Parse(format2.Text), s, miljøTillægvisesIGrid.IsChecked.Value), 2);

                s.TotalIncltillæg = Math.Round(s.FarveTotal + s.MmTotal, 2);
                avisTIlGrids.RemoveAt(index);
                avisTIlGrids.Insert(index, s);
            });
        }


        private void miljøtillægOp0kræves_Click(object sender, RoutedEventArgs e)
        {
            miljøTillægvisesIGrid.Visibility = Visibility.Visible;

        }

        private void kopierTIlNy_Click(object sender, RoutedEventArgs e)
        {
            var dialog = new LokalPlanner.dialogs.KopierTIlNyDialog();
            dialog.Visibility = Visibility.Visible;
            opretMediePlanNr(1);

        }


        public ExportOptions ExportOptions
        {
            get
            {
                if (this.ExportOptions1 == null)
                    this.ExportOptions1 = new ExportOptions();

                return this.ExportOptions1;
            }
        }

        public BureaoDao BureaoDao { get => bureaoDao; set => bureaoDao = value; }
        public AnnonøcerDAO AnnonøcerDAO { get => annonøcerDAO; set => annonøcerDAO = value; }
        public DPKuloerDao KuloerDao { get => kuloerDao; set => kuloerDao = value; }
        public PlaceringDao PlaceringDao { get => placeringDao; set => placeringDao = value; }
        public MediePlanAviserDao AviserDao { get => aviserDao; set => aviserDao = value; }
        public MediePlanLinjerDao MediePlanLinjerDao { get => mediePlanLinjerDao; set => mediePlanLinjerDao = value; }
        public MedieplanÆndringerDao MedieplanÆndringerDao { get => medieplanÆndringerDao; set => medieplanÆndringerDao = value; }
        public MediaPlanNrDao MediaPlanNrDao { get => mediaPlanNrDao; set => mediaPlanNrDao = value; }
        public List<Cell> Cells { get => _cells; set => _cells = value; }
        public MediePlanDao MediePlanDao { get => mediePlanDao; set => mediePlanDao = value; }
        internal SecurityUserService Security { get => security; set => security = value; }
        public ValidationServive ValidationServive { get => validationServive; set => validationServive = value; }
        internal BeregnerService BeregnerService { get => beregnerService; set => beregnerService = value; }
        public FarveberegnerService FarveberegnerService { get => farveberegnerService; set => farveberegnerService = value; }
        public NumberStyles Style1 { get => style; set => style = value; }
        public CultureInfo Provider { get => provider; set => provider = value; }
        public ExportOptions ExportOptions1 { get => _exportOptions; set => _exportOptions = value; }

        private string GetUnusedFileName()
        {
            for (int i = 1; i < 5000; i++)
            {
                string fileName = "DataPresenterExportToExcelTest" + i.ToString() + ".xlsx";
                if (false == System.IO.File.Exists(fileName))
                    return fileName;
            }

            return string.Empty;
        }

        private string SetVersion(string s)
        {
            System.Text.StringBuilder res = new System.Text.StringBuilder();
            if (s.Length > 1)
            {
                var e = s.ToList();
                foreach (var v in e)
                {
                    res.Append(v);
                    res.Append("-");
                }
                return res.ToString().Substring(0, res.Length - 1);
            }
            return s;
        }

        private void Annoncør_SelectedItemChanged(object sender, RoutedPropertyChangedEventArgs<object> e)
        {

            ChangeHasBeenMade();
            ChangeHasHapped("yellow1_circle");
            ValidationServive.Remove("Annnoncør mangler");
            var an = Annoncør.SelectedItem as Annoncøer;
            if (an != null)
            {
                if (an.Bill_to_Contact_No_ != "")
                {
                    var res = Bureau.Find(s => s.Company_No_ == an.Bill_to_Contact_No_).Annoncør;

                    BureauCombo.Text = res;
                }

            }
            else
            {
                BureauCombo.Text = "'-Vælg Bureau-'";
            }
        }

        private void farver_SelectedItemChanged(object sender, RoutedPropertyChangedEventArgs<object> e)
        {

            farver.Visibility = Visibility.Hidden;
            farve1.Visibility = Visibility.Visible;
            pKulør = farver.SelectedItem as DPKulør;
        }


        private void placeringCombo_SelectedItemChanged(object sender, RoutedPropertyChangedEventArgs<object> e)
        {
            ChangeHasBeenMade();
            var placering = placeringCombo.SelectedItem as Placering;
            UpdateGridAccordinToPlacering(placering.PlaceringID);
        }

        private void Opret_MouseEnter(object sender, System.Windows.Input.MouseEventArgs e)
        {

        }

        private void luk_Click(object sender, RoutedEventArgs e)
        {
            if (status_image.Source.ToString().Contains("yellow"))
            {
                MessageBox.Show("Der er lavet ændringer i medieplan husk at trykke gem først");
            }
        }



        private void Bemærkinng_KeyDown(object sender, System.Windows.Input.KeyEventArgs e)
        {
            ChangeHasBeenMade();
            if (e.Key == System.Windows.Input.Key.Tab)
            {
                if (indrÅr.Text.Length > 0)
                {
                    ValidationServive.Remove("År mangler");
                    ValidationServive.Remove("Uge mangler");
                }
                ValidationServive.Remove("Bemærkning mangler");
            }
            //  
        }

        private void Kommentar_KeyDown(object sender, System.Windows.Input.KeyEventArgs e)
        {

        }

        private void Kommentar_KeyDown_1(object sender, System.Windows.Input.KeyEventArgs e)
        {
            ChangeHasBeenMade();
            if (e.Key == System.Windows.Input.Key.Tab)
            {

                ValidationServive.Remove("Kommentar mangler");
                if (ValidationServive.Validations.Count == 0)
                {
                    ChangeHasHapped("green_circle");
                    Opret.Opacity = 100;
                }
            }
        }

        private void dækningkorrt_Click(object sender, RoutedEventArgs e)
        {
            var dialog = new LokalPlanner.dialogs.DækningsKortWindowDialig();
            dialog.Visibility = Visibility.Visible;
        }

        private void Bemærkinng_GotFocus(object sender, RoutedEventArgs e)
        {

            Bemærkinng.Document.Blocks.Clear();
        }

        private void Window_PreviewLostKeyboardFocus(object sender, System.Windows.Input.KeyboardFocusChangedEventArgs e)
        {
            //   Window window = (Window)sender;
            //  window.Topmost = false;

        }

        private void Kommentar_GotFocus(object sender, RoutedEventArgs e)
        {
            Kommentar.Document.Blocks.Clear();
        }

      


        private void mediePlaner_EditModeEnded(object sender, Infragistics.Windows.DataPresenter.Events.EditModeEndedEventArgs e)
        {
            var grid = (sender as XamDataGrid);

            var selecteditems = grid.SelectedDataItems;

            try
            {
                var label = e.Cell.Field.Label.ToString();
                var reord = ((DataRecord)e.Cell.Record).DataItem as AvisTIlGrid;
                decimal ed = decimal.Parse(e.Editor.Value.ToString());
                var exa = decimal.Parse(e.Cell.Value.ToString());
                var avisInList = avisTIlGrids.Where(s => s.BladID == reord.BladID).FirstOrDefault<AvisTIlGrid>();
                var indexInList = avisTIlGrids.IndexOf(reord);
                if (label.Equals("Total"))
                {
                    var res = BeregnerService.BeregenPrisFraTotal(oldTotalValue, exa, reord);
                    avisTIlGrids.RemoveAt(indexInList);
                    avisTIlGrids.Insert(indexInList, res);
                    mediePlaner.ActiveCell = null;
                }
                else if (label.Equals("Mm Rabat"))
                {

                    var val = e.Cell.Value;
                    if ((sender as XamDataGrid).SelectedItems.Cells.Count != 1)
                    {
                        int cnt = (sender as XamDataGrid).SelectedItems.Cells.Count;
                        for (int i = 1; i < cnt; i++)
                        {
                            (sender as XamDataGrid).SelectedItems.Cells[i].Value = val;
                        }
                    }
                    var res = BeregnerService.BeregnePrisFraMMRabt(exa, reord);
                    avisTIlGrids.RemoveAt(indexInList);
                    avisTIlGrids.Insert(indexInList, reord);
                    mediePlaner.ActiveCell = null;
                }
                else if (label.Equals("Farve Rabat"))
                {
                    var res = BeregnerService.BeregnePrisFarveRabat(exa, reord);
                    avisTIlGrids.RemoveAt(indexInList);
                    avisTIlGrids.Insert(indexInList, res);
                    mediePlaner.ActiveCell = null;
                }
            }
            catch (Exception ex)
            {

            }


           }



            private void mediePlaner_EditModeStarting(object sender, Infragistics.Windows.DataPresenter.Events.EditModeStartingEventArgs e)
        {
            try
            {
             
                var label = e.Cell.Field.Label.ToString();
                var reord = ((DataRecord)e.Cell.Record).DataItem as AvisTIlGrid;
                decimal ed = decimal.Parse(e.Editor.Value.ToString());
                var exa = decimal.Parse(e.Cell.Value.ToString());
                var avisInList = avisTIlGrids.Where(s => s.BladID == reord.BladID).FirstOrDefault<AvisTIlGrid>();
                var indexInList = avisTIlGrids.IndexOf(reord);
                if (label.Equals("Total"))
                {

                    oldTotalValue = ed;
                }
                else if (label.Equals("Mm Rabat"))
                {
                    foreach (var cell in Cells)
                    {
                        cell.IsSelected = true;
                    }
                    oldMMrabat = ed;

                                   }
                else if (label.Equals("Farve Rabat"))
                {
                    oldFarveRabat = ed;  
                }
            }
            catch (Exception ex)
            {

            }

        }



        private void mediePlaner_SelectedItemsChanged(object sender, Infragistics.Windows.DataPresenter.Events.SelectedItemsChangedEventArgs e)
        {
            if (e.Type == typeof(Cell) && this.mediePlaner.SelectedItems.Cells.Count > 0 && this.mediePlaner.ActiveCell != null)
            {
                _cells.Clear();
                foreach (var cell in this.mediePlaner.SelectedItems.Cells)
                {
                    Cells.Add(cell);
                }

           this.mediePlaner.SelectedItemsChanged -= this.mediePlaner_SelectedItemsChanged;
               CellValuePresenter.FromCell(this.mediePlaner.SelectedItems.Cells[0]).Editor.StartEditMode();
               this.mediePlaner.SelectedItemsChanged += this.mediePlaner_SelectedItemsChanged;
            }
        }

    

        private void mediePlaner_PreviewMouseLeftButtonDown(object sender, MouseButtonEventArgs e)
        {
            HitTestResult result = VisualTreeHelper.HitTest(this.mediePlaner, e.GetPosition(mediePlaner));
            if (result != null && result.VisualHit != null)
            {
                if (result.VisualHit is CellValuePresenter)
                    this.mediePlaner.SelectedItems.Cells.Clear();
                else
                {
                    CellValuePresenter cvp = (CellValuePresenter)Utilities.GetAncestorFromType(result.VisualHit, typeof(CellValuePresenter), false);
                    if (cvp != null)
                        this.mediePlaner.SelectedItems.Cells.Clear();
                }
            }
        }
    }
}
